(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* :Name: PwM`Chap07Recursion` *)


(* :Book: Programming with Mathematica: An Introduction *)


(* :Author: Paul Wellin *)


(* :Summary: This package contains the functions defined in Chapter 7 Recursion *)


(* :Context: PwM`Chap07Recursion` *)


(* :Package Version: 1.0 *)


(* :Copyright: Copyright 2012, Paul R. Wellin *)


(* :History: Version 1.0 by Paul Wellin, Dec 2012 *)


(* :Keywords: autocorrelation, condition number, correlogram, digit sum, eigenvector, root finding, lag plot, radius of gyration, sparse array, tridiagonal matrix *)


(* :Source: Chap07Recursion.nb *)


(* :Mathematica Version: 8.0.4 *)


BeginPackage["PwM`Chap07Recursion`"]


EulerianNumber::usage="EulerianNumber[n, k] returns the the number of permutations of the set {1,2,3,\[Ellipsis],n} with k increasing runs of elements.";


Begin["`Private`"]


EulerianNumber[0,k_]=0;
EulerianNumber[n_Integer,0]=1;
EulerianNumber[n_Integer,k_Integer]/;k>=n=0;


EulerianNumber[n_Integer,k_Integer]:=Block[{$RecursionLimit=Infinity},
EulerianNumber[n,k]=(k+1)EulerianNumber[n-1,k]+(n-k)EulerianNumber[n-1,k-1]]


End[]


EndPackage[]



