(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     47957,       1476]
NotebookOptionsPosition[     43098,       1305]
NotebookOutlinePosition[     43661,       1329]
CellTagsIndexPosition[     43575,       1324]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PwM`Chap04Patterns`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic",
  FontVariations->{"Underline"->True}]
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Name", ":", " ", "PwM`Chap04Patterns`"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Book", ":", " ", 
    RowBox[{"Programming", " ", "with", " ", 
     RowBox[{"Mathematica", ":", " ", 
      RowBox[{"An", " ", "Introduction"}]}]}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", "Summary", ":", " ", 
   RowBox[{
   "This", " ", "package", " ", "contains", " ", "the", " ", "functions", " ",
     "defined", " ", "in", " ", "Chapter", " ", "4", " ", "Patterns", " ", 
    "and", " ", 
    RowBox[{"rules", "."}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "PwM`Chap04Patterns`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", "Version"}], ":", " ", "1.01"}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", "Copyright", ":", " ", 
    RowBox[{"Copyright", " ", "2012"}]}], ",", " ", 
   RowBox[{"Paul", " ", 
    RowBox[{"R", ".", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{
   "Dec", " ", "2012", "\[IndentingNewLine]", "Version", " ", "1.01", " ", 
    "changed", " ", "name", " ", "of", " ", "SquareMatrixQ", " ", "to", " ", 
    "be", " ", "compatible", " ", "with", " ", "Mathematica", " ", "10", " ", 
    "Nov", " ", "2014"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{
     "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",", 
   " ", 
   RowBox[{
   "Dec", " ", "2012", "\[IndentingNewLine]", "            ", "Version", " ", 
    "1.01", " ", "by", " ", "Paul", " ", "Wellin", " ", "Nov", " ", 
    "2014"}]}], "  ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "dice"}]}], ",", " ", "arrays", ",", " ", 
   "multiplication", ",", " ", 
   RowBox[{"square", " ", "matrix"}], ",", " ", 
   RowBox[{"area", " ", "of", " ", "triangle"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Chap04Patterns", ".", "nb"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", 
   RowBox[{"10.0", ".1"}]}], " ", "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", "TriangleArea", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<PwM`Chap04Patterns`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages for public functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dice", "::", "usage"}], "=", 
   "\"\<Dice[n] displays a regular six-sided die with value n.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FixArray", "::", "usage"}], "=", 
   "\"\<FixArray[mat] replaces any occurrences of the string \\\"NAN\\\" with \
the column mean for each column in which the string appears. \>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyCount", "::", "usage"}], "=", 
   "\"\<MultiplyCount[expr] computes the number of explicit multiplications \
in the arithmetic expression expr.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"squareMatrixQ", "::", "usage"}], "=", 
   "\"\<squareMatrixQ[mat] yields true if mat is a square matrix.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TriangleArea", "::", "usage"}], "=", 
   "\"\<TriangleArea[vertices] computes the area of the triangle specified by \
the three-element list vertices.\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Dice", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Color", "\[Rule]", 
     RowBox[{"Darker", "@", "Blue"}]}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Private context", "Subsection"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions (public and private)", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dice", "[", 
   RowBox[{"n_", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rules", ",", 
      RowBox[{"off", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Color", "]"}], ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}], ",", 
      RowBox[{"on", "=", 
       RowBox[{"{", 
        RowBox[{"White", ",", 
         RowBox[{"Disk", "[", "]"}]}], "}"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rules", "=", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "off"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "off"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "off"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "off"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "off"}], ",", 
          RowBox[{"5", "\[Rule]", "on"}], ",", 
          RowBox[{"6", "\[Rule]", "off"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}], ",", "\[IndentingNewLine]",
         "\[VeryThinSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "on"}], ",", 
          RowBox[{"2", "\[Rule]", "off"}], ",", 
          RowBox[{"3", "\[Rule]", "on"}], ",", 
          RowBox[{"4", "\[Rule]", "on"}], ",", 
          RowBox[{"5", "\[Rule]", "off"}], ",", 
          RowBox[{"6", "\[Rule]", "on"}], ",", 
          RowBox[{"7", "\[Rule]", "on"}], ",", 
          RowBox[{"8", "\[Rule]", "off"}], ",", 
          RowBox[{"9", "\[Rule]", "on"}]}], "}"}]}], "\[IndentingNewLine]", 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Graphics", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Range", "[", "9", "]"}], ",", "3"}], "]"}], "/.", 
          "\[VeryThinSpace]", 
          RowBox[{"rules", "[", 
           RowBox[{"[", "n", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", 
        RowBox[{"First", "[", "off", "]"}]}], ",", 
       RowBox[{"Spacings", "\[Rule]", "10"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "40"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "mat_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "fixcolumn", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fixcolumn", "[", "col_", "]"}], ":=", 
      RowBox[{
       RowBox[{"mat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "col"}], "]"}], "]"}], "/.", 
       RowBox[{"\"\<NAN\>\"", "\[RuleDelayed]", 
        RowBox[{"Mean", "[", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"mat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "col"}], "]"}], "]"}], ",", 
           RowBox[{"_", "?", "NumberQ"}]}], "]"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"fixcolumn", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "mat", "]"}], "]"}], "]"}]}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyCount", "[", 
   RowBox[{"expr_", "?", "PolynomialQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"_", ",", "exp_"}], "]"}], "\[RuleDelayed]", 
       RowBox[{"exp", "-", "1"}]}], ",", "Infinity"}], "]"}]}], "+", 
   RowBox[{"Total", "@", 
    RowBox[{"Cases", "[", 
     RowBox[{
      RowBox[{"{", "expr", "}"}], ",", 
      RowBox[{"fac_Times", "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"Length", "[", "fac", "]"}], "-", "1"}]}], ",", "Infinity"}], 
     "]"}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"squareMatrixQ", "[", 
   RowBox[{"mat_", "/;", 
    RowBox[{"MatrixQ", "[", "mat", "]"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"Dimensions", "[", "mat", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"Dimensions", "[", "mat", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangleArea", "[", 
   RowBox[{"tri", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Det", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"PadRight", "[", 
        RowBox[{"#", ",", "3", ",", "1"}], "]"}], "&"}], ",", "tri"}], "]"}], 
    "]"}], "/", "2"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Subsection"],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell["Quit current session:", "Text"],

Cell[BoxData["Quit"], "Input"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "PWM`Chap04Patterns`"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Dice"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Dice[\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] displays \
a regular six-sided die with value \\!\\(\\*\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FixArray"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FixArray[\\!\\(\\*\\nStyleBox[\\\"mat\\\", \\\"TI\\\"]\\)] \
replaces any occurrences of the string \\\"NAN\\\" with the column mean for \
each column in which the string appears. \"\>", "MSG"]], "Print", \
"PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MultiplyCount"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"MultiplyCount[\\!\\(\\*\\nStyleBox[\\\"expr\\\", \
\\\"TI\\\"]\\)] computes the number of explicit multiplications in the \
arithmetic expression \\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\).\"\>",
   "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "squareMatrixQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"squareMatrixQ[\!\(\*\\nStyleBox[\\\"mat\\\", \\\"TI\\\"]\)] \
yields true if \!\(\*\\nStyleBox[\\\"mat\\\", \\\"TI\\\"]\) is a square \
matrix.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3626257364-1145558"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TriangleArea"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"TriangleArea[\\!\\(\\*\\nStyleBox[\\\"vertices\\\", \
\\\"TI\\\"]\\)] computes the area of the triangle specified by the \
three-element list \\!\\(\\*\\nStyleBox[\\\"vertices\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["Dice", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Dice", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "6"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], 
        {555, -925.}, ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {185, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {925, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}], ",", 
   GraphicsBox[{{{
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -740.}, {1110, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -740.}, {740, -1110.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -740.}, {370, -1110.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, -370.}, {1110, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, -370.}, {740, -740.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, -370.}, {370, -740.}]}}, {
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{740, 0}, {1110, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{370, 0}, {740, -370.}]}, 
       {RGBColor[0, 0, 
         NCache[
          Rational[2, 3], 0.6666666666666666]], 
        RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -185.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -555.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -555.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {RGBColor[0, 0, 
           NCache[
            Rational[2, 3], 0.6666666666666666]], DiskBox[{0, 0}]}], {555, -925.},
         ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
        GraphicsBox[
         {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
        ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
    ContentSelectable->True,
    ImageSize->40,
    PlotRangePadding->{6, 5}]}], "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dice", "[", 
  RowBox[{"5", ",", 
   RowBox[{"Color", "\[Rule]", "Red"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{{
     {RGBColor[1, 0, 0], RectangleBox[{740, -740.}, {1110, -1110.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, -740.}, {740, -1110.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, -740.}, {370, -1110.}]}}, {
     {RGBColor[1, 0, 0], RectangleBox[{740, -370.}, {1110, -740.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, -370.}, {740, -740.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, -370.}, {370, -740.}]}}, {
     {RGBColor[1, 0, 0], RectangleBox[{740, 0}, {1110, -370.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{370, 0}, {740, -370.}]}, 
     {RGBColor[1, 0, 0], RectangleBox[{0, 0}, {370, -370.}]}}}, {{InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {185, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {555, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {925, -185.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {185, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {555, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {925, -555.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}, {InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {185, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {RGBColor[1, 0, 0], DiskBox[{0, 0}]}], {555, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}], InsetBox[
      GraphicsBox[
       {GrayLevel[1], DiskBox[{0, 0}]}], {925, -925.}, 
      ImageScaled[{0.5, 0.5}], {360, 360.}]}}, {}},
  ContentSelectable->True,
  ImageSize->40,
  PlotRangePadding->{6, 5}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FixArray", "Subsubsection"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{"array", "=", 
    TagBox[
     RowBox[{"(", "\[NoBreak]", GridBox[{
        {"0.9034000000000001`", "\"\<NAN\>\"", "0.7163`", "0.8588`", 
         "0.1228`"},
        {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", 
         "0.8063`", "\"\<NAN\>\""},
        {"0.041800000000000004`", "0.8426`", "\"\<NAN\>\"", 
         "0.8634000000000001`", "0.9682000000000001`"},
        {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
         "0.8432000000000001`", "0.054700000000000006`"},
        {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
         "0.5589000000000001`", "0.8993`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
     Function[BoxForm`e$, 
      MatrixForm[BoxForm`e$]]]}], ";"}],
  NumberMarks->False]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FixArray", "[", "array", "]"}], "//", "MatrixForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.9034000000000001`", "0.7517750000000001`", "0.7163`", "0.8588`", 
      "0.1228`"},
     {"0.30310000000000004`", "0.5827`", "0.26990000000000003`", "0.8063`", 
      "0.51125`"},
     {"0.041800000000000004`", "0.8426`", "0.490725`", "0.8634000000000001`", 
      "0.9682000000000001`"},
     {"0.9163`", "0.8913000000000001`", "0.06620000000000001`", 
      "0.8432000000000001`", "0.054700000000000006`"},
     {"0.7937000000000001`", "0.6905`", "0.9105000000000001`", 
      "0.5589000000000001`", "0.8993`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyCount", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MultiplyCount"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"MultiplyCount[expr] computes the\[Ellipsis]\"\>", 
  "MSG"]], "Print", "PrintUsage"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MultiplyCount", "[", 
  RowBox[{
   RowBox[{"3", 
    SuperscriptBox["x", "4"]}], "-", 
   RowBox[{"5", "x"}], "+", "2"}], "]"}]], "Input"],

Cell[BoxData["5"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["squareMatrixQ", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.008675983574202961`", "0.9510957842599517`", "0.4049246512558107`", 
      "0.2059007632468084`"},
     {"0.14881612565966207`", "0.9140575361964991`", "0.9356868680953272`", 
      "0.17798744975123593`"},
     {"0.8739433111470687`", "0.5128185556992051`", "0.6631608340070085`", 
      "0.3202771646775264`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"squareMatrixQ", "[", "mat", "]"}]], "Input"],

Cell[BoxData["False"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"mat", "=", 
   RowBox[{"RandomReal", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "mat", "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.7464882504575041`", "0.4105001722599695`", "0.41367470438238163`", 
      "0.8926852946240196`"},
     {"0.973459521682585`", "0.638756367812402`", "0.8731651477864115`", 
      "0.9083565400964402`"},
     {"0.24586295604623176`", "0.8179596640082454`", "0.14200779379813855`", 
      "0.9516553206210243`"},
     {"0.23650473169127206`", "0.7062455569813144`", "0.6565678353275894`", 
      "0.1605596591174614`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"squareMatrixQ", "[", "mat", "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["TriangleArea", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TriangleArea", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "1"], ",", 
      SubscriptBox["y", "1"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "2"], ",", 
      SubscriptBox["y", "2"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["x", "3"], ",", 
      SubscriptBox["y", "3"]}], "}"}]}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["x", "2"]}], " ", 
     SubscriptBox["y", "1"]}], "+", 
    RowBox[{
     SubscriptBox["x", "3"], " ", 
     SubscriptBox["y", "1"]}], "+", 
    RowBox[{
     SubscriptBox["x", "1"], " ", 
     SubscriptBox["y", "2"]}], "-", 
    RowBox[{
     SubscriptBox["x", "3"], " ", 
     SubscriptBox["y", "2"]}], "-", 
    RowBox[{
     SubscriptBox["x", "1"], " ", 
     SubscriptBox["y", "3"]}], "+", 
    RowBox[{
     SubscriptBox["x", "2"], " ", 
     SubscriptBox["y", "3"]}]}], ")"}]}]], "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{681, 666},
WindowMargins->{{259, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3626257364-1145558"->{
  Cell[14935, 502, 247, 4, 51, "Print",
   CellTags->"Info3626257364-1145558"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3626257364-1145558", 43471, 1318}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 66, 1, 60, "Section",
 InitializationGroup->True],
Cell[648, 25, 398, 13, 29, "Text"],
Cell[CellGroupData[{
Cell[1071, 42, 30, 0, 41, "Subsection"],
Cell[1104, 44, 129, 3, 29, "Input"],
Cell[1236, 49, 239, 6, 29, "Input"],
Cell[1478, 57, 146, 4, 28, "Input"],
Cell[1627, 63, 310, 7, 46, "Input"],
Cell[1940, 72, 135, 4, 29, "Input"],
Cell[2078, 78, 136, 4, 29, "Input"],
Cell[2217, 84, 229, 6, 29, "Input"],
Cell[2449, 92, 494, 12, 63, "Input"],
Cell[2946, 106, 398, 11, 46, "Input"],
Cell[3347, 119, 294, 7, 46, "Input"],
Cell[3644, 128, 152, 4, 29, "Input"],
Cell[3799, 134, 157, 4, 28, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3993, 143, 34, 0, 33, "Subsection"],
Cell[4030, 145, 70, 1, 36, "Input"],
Cell[4103, 148, 91, 1, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4231, 154, 57, 0, 33, "Subsection"],
Cell[4291, 156, 167, 5, 28, "Input"],
Cell[4461, 163, 250, 6, 80, "Input"],
Cell[4714, 171, 223, 5, 63, "Input"],
Cell[4940, 178, 179, 5, 46, "Input"],
Cell[5122, 185, 222, 5, 63, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5381, 195, 29, 0, 33, "Subsection"],
Cell[5413, 197, 198, 6, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5648, 208, 37, 0, 33, "Subsection"],
Cell[5688, 210, 74, 1, 41, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5799, 216, 63, 0, 33, "Subsection"],
Cell[5865, 218, 4534, 110, 352, "Input"],
Cell[10402, 330, 1016, 28, 97, "Input"],
Cell[11421, 360, 683, 20, 63, "Input"],
Cell[12107, 382, 376, 11, 46, "Input"],
Cell[12486, 395, 561, 19, 46, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[13084, 419, 41, 0, 33, "Subsection"],
Cell[13128, 421, 51, 1, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[13216, 427, 32, 0, 33, "Subsection"],
Cell[13251, 429, 58, 1, 78, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13358, 436, 27, 0, 60, "Section"],
Cell[CellGroupData[{
Cell[13410, 440, 34, 0, 41, "Subsection"],
Cell[13447, 442, 37, 0, 29, "Text"],
Cell[13487, 444, 30, 0, 28, "Input"],
Cell[13520, 446, 183, 6, 29, "Text"],
Cell[13706, 454, 63, 1, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13806, 460, 41, 0, 41, "Subsection"],
Cell[CellGroupData[{
Cell[13872, 464, 47, 1, 35, "Input"],
Cell[13922, 467, 215, 3, 118, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[14174, 475, 51, 1, 28, "Input"],
Cell[14228, 478, 249, 4, 168, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[14514, 487, 56, 1, 28, "Input"],
Cell[14573, 490, 266, 4, 118, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[14876, 499, 56, 1, 28, "Input"],
Cell[14935, 502, 247, 4, 51, "Print",
 CellTags->"Info3626257364-1145558"]
}, Closed]],
Cell[CellGroupData[{
Cell[15219, 511, 55, 1, 28, "Input"],
Cell[15277, 514, 265, 4, 118, "Print"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[15591, 524, 56, 0, 33, "Subsection"],
Cell[CellGroupData[{
Cell[15672, 528, 29, 0, 43, "Subsubsection"],
Cell[CellGroupData[{
Cell[15726, 532, 172, 5, 78, "Input"],
Cell[15901, 539, 18068, 470, 168, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[34006, 1014, 116, 3, 78, "Input"],
Cell[34125, 1019, 1931, 40, 165, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[36105, 1065, 33, 0, 34, "Subsubsection"],
Cell[36141, 1067, 1225, 29, 275, "Input"],
Cell[CellGroupData[{
Cell[37391, 1100, 98, 2, 78, "Input"],
Cell[37492, 1104, 1074, 25, 265, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[38615, 1135, 38, 0, 34, "Subsubsection"],
Cell[CellGroupData[{
Cell[38678, 1139, 56, 1, 78, "Input"],
Cell[38737, 1142, 113, 2, 118, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[38887, 1149, 163, 5, 97, "Input"],
Cell[39053, 1156, 28, 0, 78, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[39130, 1162, 38, 0, 34, "Subsubsection"],
Cell[CellGroupData[{
Cell[39193, 1166, 253, 7, 57, "Input"],
Cell[39449, 1175, 873, 21, 94, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[40359, 1201, 68, 1, 28, "Input"],
Cell[40430, 1204, 32, 0, 35, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[40499, 1209, 253, 7, 49, "Input"],
Cell[40755, 1218, 977, 23, 116, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[41769, 1246, 68, 1, 28, "Input"],
Cell[41840, 1249, 31, 0, 35, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[41920, 1255, 37, 0, 34, "Subsubsection"],
Cell[CellGroupData[{
Cell[41982, 1259, 431, 15, 78, "Input"],
Cell[42416, 1276, 630, 23, 127, "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
