(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     78405,       2538]
NotebookOptionsPosition[     61832,       2004]
NotebookOutlinePosition[     65634,       2113]
CellTagsIndexPosition[     64717,       2088]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["PwM`Chap09Strings`", "Section",
 InitializationGroup->True],

Cell[TextData[{
 StyleBox["From",
  FontWeight->"Bold"],
 ": ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic",
  FontVariations->{"Underline"->True}]
}], "Text",
 CellMargins->{{28, 10}, {7, 7}},
 FontSize->14],

Cell[CellGroupData[{

Cell["Metadata", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Name", ":", " ", "PwM`Chap09Strings`"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Book", ":", " ", 
    RowBox[{"Programming", " ", "with", " ", 
     RowBox[{"Mathematica", ":", " ", 
      RowBox[{"An", " ", "Introduction"}]}]}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Author", ":", " ", 
    RowBox[{"Paul", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "contains", " ", "the", " ", "functions", 
      " ", "defined", " ", "in", " ", "Chapter", " ", "9"}]}]}], ",", " ", 
   RowBox[{"Strings", "."}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Context", ":", " ", "PwM`Chap09Strings`"}]}], " ", 
  "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Package", " ", 
    RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Copyright", ":", " ", 
     RowBox[{"Copyright", " ", "2012"}]}]}], ",", " ", 
   RowBox[{"Paul", " ", 
    RowBox[{"R", ".", " ", "Wellin"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Paul", " ", "Wellin"}]}]}], ",",
     " ", 
    RowBox[{"Dec", " ", "2012"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", "Updated", ":", " ", 
    RowBox[{
    "April", " ", "2015", " ", "to", " ", "be", " ", "compatible", " ", 
     "with", " ", "Version", " ", "10.1"}]}], " ", "*)"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{":", 
    RowBox[{"Keywords", ":", " ", "checksum"}]}], ",", " ", "hash", ",", " ", 
   "anagram", ",", " ", "blanagram", ",", " ", "subsequence", ",", " ", 
   RowBox[{"gc", " ", "ratio"}], ",", " ", "palindrome", ",", " ", 
   RowBox[{"random", " ", "strings"}], ",", " ", 
   RowBox[{"padding", " ", "strings"}], ",", " ", 
   RowBox[{"DNA", " ", "sequence", " ", "table"}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Source", ":", " ", 
    RowBox[{"Chap09Strings", ".", "nb"}]}]}], " ", "*)"}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{":", 
   RowBox[{"Mathematica", " ", "Version"}], ":", " ", 
   RowBox[{"10.1", ".0"}]}], " ", "*)"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"Remove", "[", "FindSubsequence", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<PwM`Chap09Strings`\>\"", "]"}]], "Input"],

Cell[BoxData["\<\"PwM`Chap09Strings`\"\>"], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Usage messages", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AdlerChecksum", "::", "usage"}], "=", 
   "\"\<AdlerChecksum[expr] returns the integer hash code for the expression \
expr using the Adler checksum algorithm.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Anagrams", "::", "usage"}], "=", 
   "\"\<Anagrams[word] finds all anagrams of the string word in the \
dictionary.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Blanagrams", "::", "usage"}], "=", 
   "\"\<Blanagrams[word] returns all blanagrams of word in the built-in \
dictionary.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BlockSize", "::", "usage"}], "=", 
   "\"\<BlockSize is an option to SequenceTable that specifies the size of \
the strings in each block.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FilterText", "::", "usage"}], "=", 
   "\"\<FilterText[str, lis] removes all stops words given in the list lis \
from the string str.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindSubsequence", "::", "usage"}], "=", 
   "\"\<FindSubsequence[num, subseq] returns the starting and ending \
positions of the subsequence subseq in the number num.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindWordsContaining", "::", "usage"}], "=", 
   "\"\<FindWordsContaining[str] finds all words in the built-in dictionary \
that contain the string str. The option WordPosition\[Rule]pos can be used to \
specify the position of str. pos can be either \\\"Start\\\", \\\"Middle\\\", \
\\\"End\\\", or \\\"Anywhere\\\".\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GCRatio", "::", "usage"}], "=", 
   "\"\<GCRatio[str, blocksize] computes the GC ratio in the string str for \
substrings of size blocksize.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeVarList", "::", "usage"}], "=", 
   "\"\<MakeVarList[sym, n] generates a list of n indexed \
symbols.\\nMakeVarList[sym, {n,m}] generates a list of indexed symbols from \
\!\(\*SubscriptBox[\(sym\), \(n\)]\) to \!\(\*SubscriptBox[\(sym\), \(m\)]\).\
\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrderedWordQ", "::", "usage"}], "=", 
   "\"\<OrderedWordQ[word] returns True if the characters in word are ordered \
in the sense of their character codes.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PalindromeQ", "::", "usage"}], "=", 
   "\"\<Palindrome[expr] returns True of expr is palindromic. The expression \
expr can be either a string or a number.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Palindromes", "::", "usage"}], "=", 
   "\"\<Palindromes[[n] finds all palindromic words of length n in the \
built-in dictionary.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomString", "::", "usage"}], "=", 
   "\"\<RandomString[{\!\(\*SubscriptBox[\(c\), \
\(1\)]\),\!\(\*SubscriptBox[\(c\), \
\(2\)]\),\[Ellipsis],\!\(\*SubscriptBox[\(c\), \(n\)]\)}] generates a random \
string of length n from among the characters \!\(\*SubscriptBox[\(c\), \(i\)]\
\) chosen at random. The option Weights can be used to give weighted choices \
of the characters.\\nRandomString[{list,{\!\(\*SubscriptBox[\(n\), \
\(1\)]\),\!\(\*SubscriptBox[\(n\), \(2\)]\),\[Ellipsis]}] generates an \
\!\(\*SubscriptBox[\(n\), \(1\)]\)\[Times]\!\(\*SubscriptBox[\(n\), \(2\)]\)\
\[Times]\[Ellipsis] array of random strings.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RandomString", "::", "badwt"}], "=", 
   "\"\<The length of the list of weights must be the same as the length of \
the list of characters.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SequenceTable", "::", "usage"}], "=", 
   "\"\<SequenceTable[lis] returns a formatted table suitable for displaying \
gene sequences. SequenceTable inherits options from Grid.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPad", "::", "usage"}], "=", 
   "\"\<StringPad[str,n] pads string str out to length n with \
whitespace.\\nStringPad[str,{n}] appends n whitespace characters to the end \
of str.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringPad", "::", "badlen"}], "=", 
   "\"\<Pad length `1` must be greater than the length of string `2`.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"stringPartition", "::", "usage"}], "=", 
   "\"\<stringPartition[[list,n] partitions list into non-overlapping \
sublists of strings of length n. stringPartition has the same argument \
structure as Partition.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"stringRotateLeft", "::", "usage"}], "=", 
   "\"\<stringRotateLeft[str] rotates the string one character to the \
left.\\nstringRotateLeft[str, n] rotates the string str n characters to the \
left.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UcLc", "::", "usage"}], "=", 
   "\"\<UcLc[str] converts the first character in the string str to \
uppercase.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UniqueCharacters", "::", "usage"}], "=", 
   "\"\<UniqueCharacters[str] returns a list of unique characters in the \
string str, deleting duplicates.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WordPosition", "::", "usage"}], "=", 
   "\"\<WordPosition is an option to FindWordsContaining that determines \
where the target string occurs. Possible values are \\\"Start\\\", \\\"Middle\
\\\", \\\"End\\\", or \\\"Anywhere\\\".\>\""}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "FindWordsContaining", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"WordPosition", "\[Rule]", "\"\<Start\>\""}], "}"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RandomString", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Weights", "\[Rule]", 
     RowBox[{"{", "}"}]}], "}"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SequenceTable", "]"}], "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"BlockSize", "\[Rule]", "10"}], "}"}], ",", 
     RowBox[{"Options", "[", "Grid", "]"}]}], "]"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Function definitions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdlerChecksum", "[", "str_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"codes", ",", "n", ",", "m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"codes", "=", 
      RowBox[{"ToCharacterCode", "[", "str", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"m", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Accumulate", "[", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "1", "}"}], ",", "codes"}], "]"}], "]"}], ",", 
        "65521"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"n", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Accumulate", "[", 
         RowBox[{"Rest", "[", "m", "]"}], "]"}], ",", "65521"}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Last", "[", "m", "]"}], "+", 
      RowBox[{
       RowBox[{"Last", "[", "n", "]"}], " ", "65536"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Anagrams", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "word", "]"}]}], ",", "words"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"words", "=", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"\"\<\\\\w{\>\"", "<>", 
         RowBox[{"ToString", "[", "len", "]"}], "<>", "\"\<}\>\""}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Select", "[", 
      RowBox[{"words", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "#", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Sort", "[", 
          RowBox[{"Characters", "[", "word", "]"}], "]"}]}], "&"}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Blanagrams", "[", "word_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "blana", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"blana", "=", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StringReplacePart", "[", 
            RowBox[{"word", ",", "ch", ",", 
             RowBox[{"{", 
              RowBox[{"#", ",", "#"}], "}"}]}], "]"}], "&"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"StringLength", "[", "word", "]"}], "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"ch", ",", 
          RowBox[{"CharacterRange", "[", 
           RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}], "}"}]}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"DeleteDuplicates", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Map", "[", 
        RowBox[{"Anagrams", ",", "blana", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FilterText", "[", 
   RowBox[{"str_String", ",", "stopwords_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tmp", "=", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"str", ",", 
        RowBox[{
         RowBox[{"Characters", "[", "\"\<:,;.!? \>\"", "]"}], ".."}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "@", 
      RowBox[{"StringSplit", "[", 
       RowBox[{"tmp", ",", 
        RowBox[{"WordBoundary", "~~", 
         RowBox[{"Apply", "[", 
          RowBox[{"Alternatives", ",", "stopwords"}], "]"}], "~~", 
         "WordBoundary"}], ",", 
        RowBox[{"IgnoreCase", "\[Rule]", "True"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{
    RowBox[{"num_", "?", "NumberQ"}], ",", 
    RowBox[{"subseq_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"ToString", "[", "num", "]"}]}], ",", 
      RowBox[{"s", "=", 
       RowBox[{"ToString", "[", "subseq", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"StringPosition", "[", 
     RowBox[{
      RowBox[{"Part", "[", 
       RowBox[{
        RowBox[{"StringSplit", "[", 
         RowBox[{"n", ",", "\"\<.\>\""}], "]"}], ",", "2"}], "]"}], ",", 
      "s"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindWordsContaining", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wp", "=", 
      RowBox[{"OptionValue", "[", "WordPosition", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wp", "==", "\"\<Start\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<Middle\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.+\>\"", ",", "str", ",", "\"\<.+\\\\b\>\""}], 
         "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "==", "\"\<End\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<\\\\b\>\""}], "]"}],
         "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"wp", "\[Equal]", "\"\<Anywhere\>\""}], ",", 
      RowBox[{"DictionaryLookup", "[", 
       RowBox[{"RegularExpression", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<\\\\b.*\>\"", ",", "str", ",", "\"\<.*\\\\b\>\""}], 
         "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcRatio", "[", "ls_String", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"gc", ",", "at"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gc", "=", 
      RowBox[{"StringCount", "[", 
       RowBox[{"ls", ",", 
        RowBox[{"\"\<G\>\"", "|", "\"\<C\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"at", "=", 
      RowBox[{"StringCount", "[", 
       RowBox[{"ls", ",", 
        RowBox[{"\"\<A\>\"", "|", "\"\<T\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"N", "[", 
      RowBox[{"gc", "/", 
       RowBox[{"(", 
        RowBox[{"gc", "+", "at"}], ")"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GCRatio", "[", 
   RowBox[{"str_String", ",", "blocksize_Integer"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lis", ",", "blocks"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lis", "=", 
      RowBox[{"stringPartition", "[", 
       RowBox[{"str", ",", "blocksize"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"blocks", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"i", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"StringLength", "[", "str", "]"}], ",", "blocksize"}], 
         "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"blocks", ",", 
        RowBox[{"Map", "[", 
         RowBox[{"gcRatio", ",", "lis"}], "]"}]}], "}"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GCRatio", "[", 
   RowBox[{
    RowBox[{"{", "str_String", "}"}], ",", "blocksize_Integer"}], "]"}], ":=", 
  RowBox[{"GCRatio", "[", 
   RowBox[{"str", ",", "blocksize"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeVarList", "[", 
   RowBox[{"x_Symbol", ",", "n_Integer"}], "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", 
       RowBox[{"ToString", "[", "#", "]"}]}], "&"}], ",", 
     RowBox[{"Range", "[", "n", "]"}]}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeVarList", "[", 
   RowBox[{"x_Symbol", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n_Integer", "?", "Positive"}], ",", 
      RowBox[{"m_Integer", "?", "Positive"}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"ToExpression", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", 
       RowBox[{"ToString", "[", "#", "]"}]}], "&"}], ",", 
     RowBox[{"Range", "[", 
      RowBox[{"n", ",", "m"}], "]"}]}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrderedWordQ", "[", "word_String", "]"}], ":=", 
  RowBox[{"OrderedQ", "[", 
   RowBox[{"ToCharacterCode", "[", "word", "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "str_String", "]"}], ":=", 
  RowBox[{
   RowBox[{"StringReverse", "[", "str", "]"}], "==", "str"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PalindromeQ", "[", "num_Integer", "]"}], ":=", 
  RowBox[{"PalindromeQ", "[", 
   RowBox[{"ToString", "[", "num", "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "len_Integer", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"w", "==", 
       RowBox[{"StringReverse", "[", "w", "]"}]}], " ", "&&", " ", 
      RowBox[{
       RowBox[{"StringLength", "[", "w", "]"}], "\[Equal]", "len"}]}], 
     ")"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Palindromes", "[", "]"}], ":=", 
  RowBox[{"DictionaryLookup", "[", 
   RowBox[{"w__", "/;", 
    RowBox[{"(", 
     RowBox[{"w", "==", 
      RowBox[{"StringReverse", "[", "w", "]"}]}], " ", ")"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"n_Integer:", "1"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"{", "c", "}"}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"RandomChoice", "[", 
        RowBox[{
         RowBox[{"wts", "\[Rule]", 
          RowBox[{"{", "c", "}"}]}], ",", "n"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", "c__String", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "len_Integer"}], "}"}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"wts", "=", 
      RowBox[{"OptionValue", "[", "Weights", "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"{", "c", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Length", "[", "wts", "]"}], "\[Equal]", 
       RowBox[{"Length", "[", 
        RowBox[{"{", "c", "}"}], "]"}]}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{"StringJoin", ",", 
        RowBox[{"RandomChoice", "[", 
         RowBox[{
          RowBox[{"wts", "\[Rule]", 
           RowBox[{"{", "c", "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "len"}], "}"}]}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Message", "[", 
       RowBox[{"RandomString", "::", "badwt"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.524665480351028*^9, 3.524665487450761*^9}, {
  3.524665582184537*^9, 3.524665740698756*^9}, {3.524665864068852*^9, 
  3.524665869803155*^9}, {3.524665943400193*^9, 3.5246659563119383`*^9}, {
  3.524666140682979*^9, 3.524666145392123*^9}, {3.524666187071706*^9, 
  3.524666188487198*^9}, {3.524666285132325*^9, 3.524666325461466*^9}, {
  3.524666502948704*^9, 3.524666507196312*^9}, {3.524666741932231*^9, 
  3.524666747124289*^9}, {3.524700956720539*^9, 3.52470096084039*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SequenceTable", "[", 
   RowBox[{"lis_String", ",", 
    RowBox[{"opts", ":", 
     RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"OptionValue", "[", "BlockSize", "]"}]}], ",", 
      RowBox[{"len", "=", 
       RowBox[{"StringLength", "[", "lis", "]"}]}], ",", 
      RowBox[{"rowlength", "=", "5"}], ",", "str", ",", "blocks", ",", 
      "ind"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"str", "=", 
      RowBox[{"StringPartition", "[", 
       RowBox[{"lis", ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"blocks", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"str", ",", "5", ",", "5", ",", "1", ",", "\"\< \>\""}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ind", "=", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Range", "[", "len", "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"#", ",", 
            RowBox[{"rowlength", "*", "n"}]}], "]"}], "\[Equal]", "1"}], 
         "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"blocks", ",", "ind"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", "opts", "}"}], ",", " ", 
         RowBox[{"Options", "[", "Grid", "]"}]}], "]"}], ",", 
       RowBox[{"Alignment", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Right", ",", 
            RowBox[{"{", "Left", "}"}]}], "}"}], ",", "Automatic"}], "}"}]}], 
       ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"Dividers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"True", ",", "False"}], "}"}], ",", "All"}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", 
    RowBox[{"{", "n_", "}"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", "=", 
      RowBox[{"StringLength", "[", "str", "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"len", ">", "n"}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ",", "n", ",",
         "str"}], "]"}], ",", 
      RowBox[{"StringPad", "[", 
       RowBox[{"str", ",", 
        RowBox[{"{", 
         RowBox[{"n", "-", "len"}], "}"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"str_String", ",", "n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}], ",", "str", ",", 
    RowBox[{"Table", "[", 
     RowBox[{"\"\< \>\"", ",", 
      RowBox[{"{", "m", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringPartition", "[", 
   RowBox[{"str_String", ",", "seq__"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "seq"}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringPartition", "[", 
   RowBox[{"str_String", ",", "blocksize_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"StringJoin", ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Characters", "[", "str", "]"}], ",", "blocksize", ",", 
      "blocksize", ",", "1", ",", 
      RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"stringRotateLeft", "[", 
   RowBox[{"str_", ",", 
    RowBox[{"n_:", "1"}]}], "]"}], ":=", 
  RowBox[{"StringJoin", "[", 
   RowBox[{"RotateLeft", "[", 
    RowBox[{
     RowBox[{"Characters", "[", "str", "]"}], ",", "n"}], "]"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UcLc", "[", "word_String", "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"word", ",", 
    RowBox[{
     RowBox[{"RegularExpression", "[", "\"\<(.)([a-z]+)\>\"", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"ToUpperCase", "[", "\"\<$1\>\"", "]"}], "~~", 
      "\"\<$2\>\""}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UniqueCharacters", "[", "str_String", "]"}], ":=", 
  RowBox[{"DeleteDuplicates", "[", 
   RowBox[{"Characters", "[", "str", "]"}], "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["End Private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["EndPackage", "Subsection"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Load package", "Subsection"],

Cell[BoxData["Quit"], "Input"],

Cell[TextData[{
 "Load package (do ",
 StyleBox["not",
  FontSlant->"Italic"],
 " say \[OpenCurlyDoubleQuote]Yes\[CloseCurlyDoubleQuote] to evaluate init \
cells dialog)."
}], "Text"],

Cell[BoxData[
 RowBox[{"<<", "PWM`Chap09Strings`"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test usage messages", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AdlerChecksum"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"AdlerChecksum[\\!\\(\\*\\nStyleBox[\\\"expr\\\", \
\\\"TI\\\"]\\)] returns the integer hash code for the expression \
\\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) using the Adler checksum \
algorithm.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706972-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Anagrams"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Anagrams[\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\)] \
finds all anagrams of the string \\!\\(\\*\\nStyleBox[\\\"word\\\", \
\\\"TI\\\"]\\) in the dictionary.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706975-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Blanagrams"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Blanagrams[\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\)] \
returns all blanagrams of \\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\) \
in the built-in dictionary.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563706978-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlockSize"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"BlockSize is an option to SequenceTable that specifies the \
size of the strings in each block.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707101-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FilterText"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FilterText[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)\\!\
\\(\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \\\
\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"lis\\\", \\\"TI\\\"]\\)] removes all \
stops words given in the list \\!\\(\\*\\nStyleBox[\\\"lis\\\", \
\\\"TI\\\"]\\) from the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707107-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FindSubsequence"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FindSubsequence[\\!\\(\\*\\nStyleBox[\\\"num\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"subseq\\\", \\\"TI\\\"]\\)] returns \
the starting and ending positions of the subsequence \
\\!\\(\\*\\nStyleBox[\\\"subseq\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \
\\\", \\\"TI\\\"]\\)in the number \\!\\(\\*\\nStyleBox[\\\"num\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\".\\\", \\\"TI\\\"]\\)\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707110-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FindWordsContaining"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"FindWordsContaining[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\
\"]\\)] finds all words in the built-in dictionary that contain the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\). The option WordPosition\
\[Rule]\\!\\(\\*\\nStyleBox[\\\"pos\\\", \\\"TI\\\"]\\) can be used to \
specify the position of \\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\). \\!\
\\(\\*\\nStyleBox[\\\"pos\\\", \\\"TI\\\"]\\) can be either \\\"Start\\\", \\\
\"Middle\\\", \\\"End\\\", or \\\"Anywhere\\\".\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707113-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GCRatio"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"GCRatio[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)\\!\\(\
\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"blocksize\\\", \\\"TI\\\"]\\)] \
computes the GC ratio in the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\) for substrings of size \\!\\(\\*\\nStyleBox[\\\"blocksize\\\", \
\\\"TI\\\"]\\).\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707120-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MakeVarList"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"MakeVarList[\\!\\(\\*\\nStyleBox[\\\"sym\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] generates a \
list of \\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) indexed \
symbols.\\nMakeVarList[\\!\\(\\*\\nStyleBox[\\\"sym\\\", \\\"TI\\\"]\\)\\!\\(\
\\*\\nStyleBox[\\\",\\\", \\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\" \\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"{\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\",\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"m\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"}\\\", \\\"TI\\\"]\\)] generates a \
list of indexed symbols from \\!\\(\\*SubscriptBox[\\nStyleBox[\\nStyleBox[\\\
\"sym\\\", \\\"TI\\\"],\\nFontWeight->\\\"Plain\\\"], \\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]]\\) to \\!\\(\\*SubscriptBox[\\nStyleBox[\\\"sym\\\", \
\\\"TI\\\"], \\nStyleBox[\\\"m\\\", \\\"TI\\\"]]\\).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707126-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "OrderedWordQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"OrderedWordQ[\\!\\(\\*\\nStyleBox[\\\"word\\\", \
\\\"TI\\\"]\\)] returns True if the characters in \
\\!\\(\\*\\nStyleBox[\\\"word\\\", \\\"TI\\\"]\\) are ordered in the sense of \
their character codes.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707129-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PalindromeQ"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Palindrome[\\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\)] \
returns True of \\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) is \
palindromic. The expression \\!\\(\\*\\nStyleBox[\\\"expr\\\", \\\"TI\\\"]\\) \
can be either a string or a number.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707132-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Palindromes"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Palindromes[[\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] \
finds all palindromic words of length \\!\\(\\*\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"]\\) in the built-in dictionary.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707136-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RandomString"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"RandomString[\\!\\(\\*\\nStyleBox[\\\"{\\\", \\\"TI\\\"]\\)\\!\
\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \
\\(1\\)]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \
\\(2\\)]\\),\[Ellipsis],\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\
\"], \\(n\\)]\\)}] generates a random string of length \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) from among the characters \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"c\\\", \\\"TI\\\"], \\(i\\)]\\) chosen \
at random. The option Weights can be used to give weighted choices of the \
characters.\\nRandomString[\\!\\(\\*\\nStyleBox[\\\"{\\\", \
\\\"TI\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"list\\\", \
\\\"TI\\\"]\\),{\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \
\\nStyleBox[\\\"1\\\", \
\\\"TR\\\"]]\\),\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \
\\nStyleBox[\\\"2\\\", \\\"TR\\\"]]\\),\\!\\(\\*\\nStyleBox[\\\"\[Ellipsis]\\\
\", \\\"TR\\\"]\\)}] generates an \
\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \\\"TI\\\"], \\nStyleBox[\\\"1\\\
\", \\\"TR\\\"]]\\)\[Times]\\!\\(\\*SubscriptBox[\\nStyleBox[\\\"n\\\", \
\\\"TI\\\"], \\nStyleBox[\\\"2\\\", \\\"TR\\\"]]\\)\[Times]\[Ellipsis] array \
of random strings.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707139-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SequenceTable"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"SequenceTable[\\!\\(\\*\\nStyleBox[\\\"lis\\\", \
\\\"TI\\\"]\\)] returns a formatted table suitable for displaying gene \
sequences. SequenceTable inherits options from Grid.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707143-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StringPad"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StringPad[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\),\\!\
\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] pads string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\) out to length \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\) with \
whitespace.\\nStringPad[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\),{\\!\
\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)}] appends \\!\\(\\*\\nStyleBox[\\\
\"n\\\", \\\"TI\\\"]\\) whitespace characters to the end of \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707145-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "stringPartition"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"stringPartition[[\!\(\*\\nStyleBox[\\\"list\\\", \
\\\"TI\\\"]\),\!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\)] partitions \
\!\(\*\\nStyleBox[\\\"list\\\", \\\"TI\\\"]\) into non-overlapping sublists \
of strings of length \!\(\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\). \
stringPartition has the same argument structure as Partition.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3637581008-3104349"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "stringRotateLeft"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"StringRotateLeft[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\
\\)] rotates the string one character to the \
left.\\nStringRotateLeft[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"n\\\", \\\"TI\\\"]\\)] rotates the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\) \\!\\(\\*\\nStyleBox[\\\"n\\\
\", \\\"TI\\\"]\\) characters to the left.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563708525-8207676"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "UcLc"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"UcLc[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\)] \
converts the first character in the string \\!\\(\\*\\nStyleBox[\\\"str\\\", \
\\\"TI\\\"]\\) to uppercase.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707151-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "UniqueCharacters"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"UniqueCharacters[\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\
\\)] returns a list of unique characters in the string \
\\!\\(\\*\\nStyleBox[\\\"str\\\", \\\"TI\\\"]\\), deleting duplicates.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563707154-2531470"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "WordPosition"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"WordPosition is an option to FindWordsContaining that \
determines where the target string occurs. Possible values are \\\"Start\\\", \
\\\"Middle\\\", \\\"End\\\", or \\\"Anywhere\\\".\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->"Info3563707264-2531470"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise the functions and options", "Subsection"],

Cell[CellGroupData[{

Cell["AdlerChecksum", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AdlerChecksum", "[", "\"\<Mathematica\>\"", "]"}]], "Input"],

Cell[BoxData["434111583"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Hash", "[", 
  RowBox[{"\"\<Mathematica\>\"", ",", "\"\<Adler32\>\""}], "]"}]], "Input"],

Cell[BoxData["434111583"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Anagrams", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Anagrams", "[", "\"\<parsley\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"parleys\"\>", ",", "\<\"parsley\"\>", ",", "\<\"players\"\>", 
   ",", "\<\"replays\"\>", ",", "\<\"sparely\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Blanagrams", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Blanagrams", "[", "\"\<zydeco\>\"", "]"}], "//", 
  "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.632435000000001`", ",", 
   RowBox[{"{", 
    RowBox[{"\<\"zydeco\"\>", ",", "\<\"cloyed\"\>", ",", "\<\"comedy\"\>", 
     ",", "\<\"decoys\"\>"}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["BlockSize", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", 
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\"\<C\>\"", ",", "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<G\>\""}], 
     "}"}], ",", "178"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"\
GCAAGCTTGGGCCAGGTGCACCGTTAAACTCTTACGAATGTAGAAGCCTGACTTCGGTCGGGCATGCGACCTTCTAGT\
GATACACTGCTTATGATGAATCACATTCCGTCCGTGCGACCCCCGGAACGCGAGGGAGCGAACATTGCTCTGGCTAAT\
CTTTAGGGGGCGTCACGCGGGA\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", 
  RowBox[{"str", ",", 
   RowBox[{"BlockSize", "\[Rule]", "12"}], ",", 
   RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"FontSize", "\[Rule]", "8"}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"GCAAGCTTGGGC\"\>", "\<\"CAGGTGCACCGT\"\>", "\<\"TAAACTCTTACG\"\
\>", "\<\"AATGTAGAAGCC\"\>", "\<\"TGACTTCGGTCG\"\>"},
    {"61", "\<\"GGCATGCGACCT\"\>", "\<\"TCTAGTGATACA\"\>", \
"\<\"CTGCTTATGATG\"\>", "\<\"AATCACATTCCG\"\>", "\<\"TCCGTGCGACCC\"\>"},
    {"121", "\<\"CCGGAACGCGAG\"\>", "\<\"GGAGCGAACATT\"\>", "\<\"GCTCTGGCTAAT\
\"\>", "\<\"CTTTAGGGGGCG\"\>", "\<\"TCACGCGGGA\"\>"}
   },
   AutoDelete->False,
   BaseStyle->Directive[FontSize -> 8],
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FilterText", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"file", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
    "$BaseDirectory", ",", "\"\<Applications\>\"", ",", "\"\<PwM\>\"", ",", 
     "\"\<Data\>\"", ",", "\"\<StopWords.dat\>\""}], "}"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"/Library/Mathematica/Applications/PwM/Data/StopWords.dat\"\>\
"], "Output"]
}, Closed]],

Cell[BoxData[
 RowBox[{"stopwords", "=", 
  RowBox[{"Rest", "@", 
   RowBox[{"Import", "[", 
    RowBox[{"file", ",", "\"\<List\>\""}], "]"}]}]}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterText", "[", 
  RowBox[{"\"\<What is the meaning of life?\>\"", ",", "stopwords"}], 
  "]"}]], "Input",
 CellTags->"9.4 Solutions"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"meaning\"\>", ",", "\<\"life\"\>"}], "}"}]], "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FindSubsequence", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pidigs", "=", 
   RowBox[{"N", "[", 
    RowBox[{"\[Pi]", ",", 
     SuperscriptBox["10", "7"]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FindSubsequence", "[", 
   RowBox[{"pidigs", ",", "314159"}], "]"}], "//", "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.315388999999996`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"176451", ",", "176456"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1259351", ",", "1259356"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1761051", ",", "1761056"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6467324", ",", "6467329"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6518294", ",", "6518299"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9753731", ",", "9753736"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9973760", ",", "9973765"}], "}"}]}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FindWordsContaining", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<Anywhere\>\""}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"cited\"\>", ",", "\<\"cites\"\>", ",", "\<\"elicited\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"excited\"\>", ",", "\<\"excitedly\"\>", 
   ",", "\<\"excitement\"\>", ",", "\<\"excitements\"\>", 
   ",", "\<\"exciter\"\>", ",", "\<\"exciters\"\>", ",", "\<\"excites\"\>", 
   ",", "\<\"incite\"\>", ",", "\<\"incited\"\>", ",", "\<\"incitement\"\>", 
   ",", "\<\"incitements\"\>", ",", "\<\"inciter\"\>", 
   ",", "\<\"inciters\"\>", ",", "\<\"incites\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"Lucites\"\>", ",", "\<\"overexcite\"\>", 
   ",", "\<\"overexcited\"\>", ",", "\<\"overexcites\"\>", 
   ",", "\<\"plebiscite\"\>", ",", "\<\"plebiscites\"\>", 
   ",", "\<\"recite\"\>", ",", "\<\"recited\"\>", ",", "\<\"reciter\"\>", 
   ",", "\<\"reciters\"\>", ",", "\<\"recites\"\>", ",", "\<\"solicited\"\>", 
   ",", "\<\"unexcited\"\>", ",", "\<\"unsolicited\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GCRatio", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hsMito", "=", 
   RowBox[{"Import", "[", "\"\<ExampleData/mitochondrion.fa.gz\>\"", "]"}]}], 
  ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GCRatio", "[", 
  RowBox[{"hsMito", ",", "1000"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0.46`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1001", ",", "0.441`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2001", ",", "0.43`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3001", ",", "0.478`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4001", ",", "0.427`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5001", ",", "0.439`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6001", ",", "0.474`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7001", ",", "0.438`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8001", ",", "0.434`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9001", ",", "0.461`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10001", ",", "0.396`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11001", ",", "0.448`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12001", ",", "0.429`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13001", ",", "0.471`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14001", ",", "0.435`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15001", ",", "0.446`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"16001", ",", "0.46409807355516636`"}], "}"}]}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MakeVarList", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeVarList", "[", 
  RowBox[{"tmp", ",", "6"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "tmp1", ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6"}], 
  "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeVarList", "[", 
  RowBox[{"tmp", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "8"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"tmp4", ",", "tmp5", ",", "tmp6", ",", "tmp7", ",", "tmp8"}], 
  "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OrderedWordQ", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OrderedWordQ", "[", "\"\<best\>\"", "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PalindromeQ", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<mood\>\"", "]"}]], "Input"],

Cell[BoxData["False"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PalindromeQ", "[", "\"\<kayak\>\"", "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"words", "=", 
   RowBox[{"DictionaryLookup", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Select", "[", 
  RowBox[{"words", ",", "PalindromeQ"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"aha\"\>", ",", "\<\"aka\"\>", 
   ",", "\<\"bib\"\>", ",", "\<\"bob\"\>", ",", "\<\"boob\"\>", 
   ",", "\<\"bub\"\>", ",", "\<\"CFC\"\>", ",", "\<\"civic\"\>", 
   ",", "\<\"dad\"\>", ",", "\<\"deed\"\>", ",", "\<\"deified\"\>", 
   ",", "\<\"did\"\>", ",", "\<\"dud\"\>", ",", "\<\"DVD\"\>", 
   ",", "\<\"eke\"\>", ",", "\<\"ere\"\>", ",", "\<\"eve\"\>", 
   ",", "\<\"ewe\"\>", ",", "\<\"eye\"\>", ",", "\<\"gag\"\>", 
   ",", "\<\"gig\"\>", ",", "\<\"huh\"\>", ",", "\<\"I\"\>", 
   ",", "\<\"kayak\"\>", ",", "\<\"kook\"\>", ",", "\<\"level\"\>", 
   ",", "\<\"ma'am\"\>", ",", "\<\"madam\"\>", ",", "\<\"mam\"\>", 
   ",", "\<\"MGM\"\>", ",", "\<\"minim\"\>", ",", "\<\"mom\"\>", 
   ",", "\<\"mum\"\>", ",", "\<\"nan\"\>", ",", "\<\"non\"\>", 
   ",", "\<\"noon\"\>", ",", "\<\"nun\"\>", ",", "\<\"oho\"\>", 
   ",", "\<\"pap\"\>", ",", "\<\"peep\"\>", ",", "\<\"pep\"\>", 
   ",", "\<\"pip\"\>", ",", "\<\"poop\"\>", ",", "\<\"pop\"\>", 
   ",", "\<\"pup\"\>", ",", "\<\"radar\"\>", ",", "\<\"redder\"\>", 
   ",", "\<\"refer\"\>", ",", "\<\"repaper\"\>", ",", "\<\"reviver\"\>", 
   ",", "\<\"rotor\"\>", ",", "\<\"sagas\"\>", ",", "\<\"sees\"\>", 
   ",", "\<\"seres\"\>", ",", "\<\"sexes\"\>", ",", "\<\"shahs\"\>", 
   ",", "\<\"sis\"\>", ",", "\<\"solos\"\>", ",", "\<\"SOS\"\>", 
   ",", "\<\"stats\"\>", ",", "\<\"stets\"\>", ",", "\<\"tat\"\>", 
   ",", "\<\"tenet\"\>", ",", "\<\"TNT\"\>", ",", "\<\"toot\"\>", 
   ",", "\<\"tot\"\>", ",", "\<\"tut\"\>", ",", "\<\"wow\"\>", 
   ",", "\<\"WWW\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Palindromes", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Palindromes", "[", "7", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomString", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], 
  "]"}]], "Input"],

Cell[BoxData["\<\"C\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   "10"}], "]"}]], "Input"],

Cell[BoxData["\<\"TCTTACACAT\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AATATATTCC\"\>", ",", "\<\"AAACAACCCT\"\>", 
   ",", "\<\"CCATAACCTA\"\>", ",", "\<\"TCCCATCCTT\"\>"}], "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7", ",", ".1"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"TCAACCACCT\"\>", ",", "\<\"TCCCTTCCCA\"\>", 
   ",", "\<\"CTAAATCCCC\"\>", ",", "\<\"CCATCCCCAT\"\>"}], "}"}]], "Output"]
}, Closed]],

Cell[RawData["Cell[\"Check bad input:\", \"Text\"]"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RandomString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<A\>\"", ",", "\"\<C\>\"", ",", "\"\<T\>\""}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "10"}], "}"}], ",", 
   RowBox[{"Weights", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".2", ",", ".7"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"RandomString", "::", "badwt"}], "MessageName"], ":", 
  " ", "\<\"The length of the list of weights must be the same as the length \
of the list of characters.\"\>"}]], "Message", "MSG"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SequenceTable", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"str", "=", 
  RowBox[{"RandomString", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\"\<C\>\"", ",", "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<G\>\""}], 
     "}"}], ",", "178"}], "]"}]}]], "Input"],

Cell[BoxData["\<\"\
TGGCGGGGGACTCCTCTCTGCGAGATAAATCGAGTCGCCATCTGGGAGGAGAGATAGGCTCTGCTTCCGGACGCGGTT\
TCGTACTCCAACGGGTGTAACTACGGGCGTGAATGGCAGGTCGCCAAACGCATTTCTGGCGAGCTAACTGGAATCGCG\
TTTGCATGCCACGCCTTCCAAC\"\>"], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", "str", "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"TGGCGGGGGA\"\>", "\<\"CTCCTCTCTG\"\>", "\<\"CGAGATAAAT\"\>", "\
\<\"CGAGTCGCCA\"\>", "\<\"TCTGGGAGGA\"\>"},
    {"51", "\<\"GAGATAGGCT\"\>", "\<\"CTGCTTCCGG\"\>", "\<\"ACGCGGTTTC\"\>", \
"\<\"GTACTCCAAC\"\>", "\<\"GGGTGTAACT\"\>"},
    {"101", "\<\"ACGGGCGTGA\"\>", "\<\"ATGGCAGGTC\"\>", "\<\"GCCAAACGCA\"\>", \
"\<\"TTTCTGGCGA\"\>", "\<\"GCTAACTGGA\"\>"},
    {"151", "\<\"ATCGCGTTTG\"\>", "\<\"CATGCCACGC\"\>", "\<\"CTTCCAAC\"\>", "\
\<\" \"\>", "\<\" \"\>"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SequenceTable", "[", 
  RowBox[{"str", ",", 
   RowBox[{"BlockSize", "\[Rule]", "12"}], ",", 
   RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"Directive", "[", 
     RowBox[{"FontSize", "\[Rule]", "8"}], "]"}]}]}], "]"}]], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"TGGCGGGGGACT\"\>", "\<\"CCTCTCTGCGAG\"\>", "\<\"ATAAATCGAGTC\"\
\>", "\<\"GCCATCTGGGAG\"\>", "\<\"GAGAGATAGGCT\"\>"},
    {"61", "\<\"CTGCTTCCGGAC\"\>", "\<\"GCGGTTTCGTAC\"\>", \
"\<\"TCCAACGGGTGT\"\>", "\<\"AACTACGGGCGT\"\>", "\<\"GAATGGCAGGTC\"\>"},
    {"121", "\<\"GCCAAACGCATT\"\>", "\<\"TCTGGCGAGCTA\"\>", "\<\"ACTGGAATCGCG\
\"\>", "\<\"TTTGCATGCCAC\"\>", "\<\"GCCTTCCAAC\"\>"}
   },
   AutoDelete->False,
   BaseStyle->Directive[FontSize -> 8],
   GridBoxAlignment->{"Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {True, False}, "Rows" -> {{True}}},
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["StringPad", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "8"}], "]"}], "//", "FullForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<ciao    \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "5", ",", "5"}], "]"}], "//", 
  "FullForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox["\"\<     ciao     \>\"",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"StringPad", "[", 
   RowBox[{"\"\<ciao\>\"", ",", "3"}], "]"}], "//", "FullForm"}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringPad", "::", "badlen"}], "MessageName"], ":", 
  " ", "\<\"Pad length \[NoBreak]\\!\\(3\\)\[NoBreak] must be greater than \
the length of string \[NoBreak]\\!\\(\\\"ciao\\\"\\)\[NoBreak].\"\>"}]], \
"Message", "MSG"],

Cell[BoxData[
 TagBox[
  StyleBox["Null",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["stringPartition", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", 
   RowBox[{"GenomeData", "[", "\"\<IGHVII671\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"stringPartition", "[", 
  RowBox[{"str", ",", "12"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ATGTCCTATTCA\"\>", ",", "\<\"GGAGCAGCTACA\"\>", 
   ",", "\<\"GCAGTCATGCCT\"\>", ",", "\<\"AGGTGTGAAGAT\"\>", 
   ",", "\<\"CACACACTGACC\"\>", ",", "\<\"TCACCCATGCTG\"\>", 
   ",", "\<\"TCTCTGGCCACT\"\>", ",", "\<\"TCATCACAACCA\"\>", 
   ",", "\<\"ATGCTTAATATT\"\>", ",", "\<\"GGACGTGGATCT\"\>", 
   ",", "\<\"GCCAGTCCCCGG\"\>", ",", "\<\"GGAATGGGTTGA\"\>", 
   ",", "\<\"ATGGAT\"\>"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomString", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<A\>\"", ",", "\"\<T\>\"", ",", "\"\<C\>\"", ",", "\"\<G\>\""}], 
      "}"}], ",", 
     SuperscriptBox["10", "2"]}], "]"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringPartition", "[", 
  RowBox[{"data", ",", "10"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ACAAATGAAT\"\>", ",", "\<\"GTCACATCAG\"\>", 
   ",", "\<\"CAAGATTGCC\"\>", ",", "\<\"TTCTGACTGC\"\>", 
   ",", "\<\"ATATATATTA\"\>", ",", "\<\"GGTCTAAGGG\"\>", 
   ",", "\<\"GCACAGCCTC\"\>", ",", "\<\"GAGGTGAGGC\"\>", 
   ",", "\<\"GCCACGCTAA\"\>", ",", "\<\"ATTGCAGCGG\"\>"}], "}"}]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["stringRotateLeft", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stringRotateLeft", "[", 
  RowBox[{"\"\<three quarks for Muster Mark \>\"", ",", "12"}], 
  "]"}]], "Input"],

Cell[BoxData["\<\" for Muster Mark three quarks\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["UcLc", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UcLc", "[", "\"\<ciao\>\"", "]"}]], "Input"],

Cell[BoxData["\<\"Ciao\"\>"], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["UniqueCharacters", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UniqueCharacters", "[", "\"\<Mississippi\>\"", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"M\"\>", ",", "\<\"i\"\>", ",", "\<\"s\"\>", ",", "\<\"p\"\>"}],
   "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["WordPosition", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindWordsContaining", "[", 
  RowBox[{"\"\<cite\>\"", ",", 
   RowBox[{"WordPosition", "\[Rule]", "\"\<End\>\""}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"anthracite\"\>", ",", "\<\"calcite\"\>", ",", "\<\"cite\"\>", 
   ",", "\<\"excite\"\>", ",", "\<\"incite\"\>", ",", "\<\"Lucite\"\>", 
   ",", "\<\"overexcite\"\>", ",", "\<\"plebiscite\"\>", 
   ",", "\<\"recite\"\>"}], "}"}]], "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
ScreenStyleEnvironment->"Working",
WindowSize->{794, 645},
WindowMargins->{{92, Automatic}, {Automatic, 12}},
ShowSelection->True,
FrontEndVersion->"10.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 23, \
2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3563706972-2531470"->{
  Cell[30323, 967, 309, 5, 183, "Print",
   CellTags->"Info3563706972-2531470"]},
 "Info3563706975-2531470"->{
  Cell[30723, 980, 269, 4, 183, "Print",
   CellTags->"Info3563706975-2531470"]},
 "Info3563706978-2531470"->{
  Cell[31085, 992, 273, 4, 183, "Print",
   CellTags->"Info3563706978-2531470"]},
 "Info3563707101-2531470"->{
  Cell[31450, 1004, 199, 3, 183, "Print",
   CellTags->"Info3563707101-2531470"]},
 "Info3563707107-2531470"->{
  Cell[31742, 1015, 471, 7, 183, "Print",
   CellTags->"Info3563707107-2531470"]},
 "Info3563707110-2531470"->{
  Cell[32311, 1030, 596, 10, 183, "Print",
   CellTags->"Info3563707110-2531470"]},
 "Info3563707113-2531470"->{
  Cell[33009, 1048, 600, 9, 340, "Print",
   CellTags->"Info3563707113-2531470"]},
 "Info3563707120-2531470"->{
  Cell[33699, 1065, 481, 7, 183, "Print",
   CellTags->"Info3563707120-2531470"]},
 "Info3563707126-2531470"->{
  Cell[34274, 1080, 1090, 18, 272, "Print",
   CellTags->"Info3563707126-2531470"]},
 "Info3563707129-2531470"->{
  Cell[35459, 1106, 308, 5, 183, "Print",
   CellTags->"Info3563707129-2531470"]},
 "Info3563707132-2531470"->{
  Cell[35861, 1119, 354, 5, 183, "Print",
   CellTags->"Info3563707132-2531470"]},
 "Info3563707136-2531470"->{
  Cell[36309, 1132, 283, 5, 183, "Print",
   CellTags->"Info3563707136-2531470"]},
 "Info3563707139-2531470"->{
  Cell[36687, 1145, 1317, 20, 346, "Print",
   CellTags->"Info3563707139-2531470"]},
 "Info3563707143-2531470"->{
  Cell[38100, 1173, 281, 5, 262, "Print",
   CellTags->"Info3563707143-2531470"]},
 "Info3563707145-2531470"->{
  Cell[38473, 1186, 617, 10, 262, "Print",
   CellTags->"Info3563707145-2531470"]},
 "Info3637581008-3104349"->{
  Cell[39188, 1204, 435, 7, 58, "Print",
   CellTags->"Info3637581008-3104349"]},
 "Info3563708525-8207676"->{
  Cell[39722, 1219, 484, 8, 262, "Print",
   CellTags->"Info3563708525-8207676"]},
 "Info3563707151-2531470"->{
  Cell[40293, 1235, 268, 4, 183, "Print",
   CellTags->"Info3563707151-2531470"]},
 "Info3563707154-2531470"->{
  Cell[40660, 1247, 298, 5, 183, "Print",
   CellTags->"Info3563707154-2531470"]},
 "Info3563707264-2531470"->{
  Cell[41053, 1260, 291, 5, 262, "Print",
   CellTags->"Info3563707264-2531470"]},
 "9.4 Solutions"->{
  Cell[44921, 1402, 184, 5, 121, "Input",
   CellTags->"9.4 Solutions"],
  Cell[45130, 1411, 160, 4, 121, "Input",
   CellTags->"9.4 Solutions"],
  Cell[45293, 1417, 126, 3, 121, "Output",
   CellTags->"9.4 Solutions"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3563706972-2531470", 62240, 2018},
 {"Info3563706975-2531470", 62351, 2021},
 {"Info3563706978-2531470", 62462, 2024},
 {"Info3563707101-2531470", 62573, 2027},
 {"Info3563707107-2531470", 62685, 2030},
 {"Info3563707110-2531470", 62797, 2033},
 {"Info3563707113-2531470", 62910, 2036},
 {"Info3563707120-2531470", 63022, 2039},
 {"Info3563707126-2531470", 63134, 2042},
 {"Info3563707129-2531470", 63248, 2045},
 {"Info3563707132-2531470", 63360, 2048},
 {"Info3563707136-2531470", 63472, 2051},
 {"Info3563707139-2531470", 63584, 2054},
 {"Info3563707143-2531470", 63698, 2057},
 {"Info3563707145-2531470", 63810, 2060},
 {"Info3637581008-3104349", 63923, 2063},
 {"Info3563708525-8207676", 64034, 2066},
 {"Info3563707151-2531470", 64146, 2069},
 {"Info3563707154-2531470", 64258, 2072},
 {"Info3563707264-2531470", 64370, 2075},
 {"9.4 Solutions", 64473, 2078}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 65, 1, 60, "Section",
 InitializationGroup->True],
Cell[490, 18, 398, 13, 29, "Text"],
Cell[CellGroupData[{
Cell[913, 35, 30, 0, 41, "Subsection"],
Cell[946, 37, 128, 3, 36, "Input"],
Cell[1077, 42, 239, 6, 36, "Input"],
Cell[1319, 50, 146, 4, 35, "Input"],
Cell[1468, 56, 317, 8, 57, "Input"],
Cell[1788, 66, 134, 4, 36, "Input"],
Cell[1925, 72, 147, 4, 36, "Input"],
Cell[2075, 78, 245, 7, 36, "Input"],
Cell[2323, 87, 505, 14, 57, "Input"],
Cell[2831, 103, 459, 9, 78, "Input"],
Cell[3293, 114, 151, 4, 36, "Input"],
Cell[3447, 120, 157, 4, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3641, 129, 34, 0, 33, "Subsection"],
Cell[3678, 131, 73, 1, 36, "Input"],
Cell[CellGroupData[{
Cell[3776, 136, 90, 1, 36, "Input"],
Cell[3869, 139, 53, 0, 56, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3971, 145, 36, 0, 33, "Subsection"],
Cell[4010, 147, 230, 5, 63, "Input"],
Cell[4243, 154, 187, 5, 46, "Input"],
Cell[4433, 161, 193, 5, 46, "Input"],
Cell[4629, 168, 210, 5, 63, "Input"],
Cell[4842, 175, 205, 5, 63, "Input"],
Cell[5050, 182, 238, 5, 63, "Input"],
Cell[5291, 189, 388, 7, 97, "Input"],
Cell[5682, 198, 212, 5, 63, "Input"],
Cell[5897, 205, 326, 7, 65, "Input"],
Cell[6226, 214, 228, 5, 63, "Input"],
Cell[6457, 221, 228, 5, 63, "Input"],
Cell[6688, 228, 202, 5, 63, "Input"],
Cell[6893, 235, 698, 12, 114, "Input"],
Cell[7594, 249, 211, 5, 63, "Input"],
Cell[7808, 256, 250, 6, 63, "Input"],
Cell[8061, 264, 256, 6, 80, "Input"],
Cell[8320, 272, 180, 5, 28, "Input"],
Cell[8503, 279, 281, 6, 80, "Input"],
Cell[8787, 287, 269, 6, 80, "Input"],
Cell[9059, 295, 182, 5, 28, "Input"],
Cell[9244, 302, 221, 5, 63, "Input"],
Cell[9468, 309, 303, 6, 80, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[9808, 320, 29, 0, 33, "Subsection"],
Cell[9840, 322, 201, 6, 36, "Input"],
Cell[10044, 330, 195, 6, 36, "Input"],
Cell[10242, 338, 279, 8, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[10558, 351, 43, 0, 33, "Subsection"],
Cell[10604, 353, 92, 2, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[10733, 360, 42, 0, 33, "Subsection"],
Cell[10778, 362, 1025, 29, 113, "Input"],
Cell[11806, 393, 924, 25, 79, "Input"],
Cell[12733, 420, 1144, 30, 113, "Input"],
Cell[13880, 452, 829, 22, 96, "Input"],
Cell[14712, 476, 708, 21, 79, "Input"],
Cell[15423, 499, 1638, 37, 214, "Input"],
Cell[17064, 538, 749, 22, 98, "Input"],
Cell[17816, 562, 905, 24, 96, "Input"],
Cell[18724, 588, 226, 6, 29, "Input"],
Cell[18953, 596, 386, 11, 46, "Input"],
Cell[19342, 609, 540, 16, 46, "Input"],
Cell[19885, 627, 180, 4, 29, "Input"],
Cell[20068, 633, 166, 4, 29, "Input"],
Cell[20237, 639, 174, 4, 29, "Input"],
Cell[20414, 645, 389, 11, 46, "Input"],
Cell[20806, 658, 258, 8, 29, "Input"],
Cell[21067, 668, 1248, 34, 130, "Input"],
Cell[22318, 704, 1984, 48, 147, "Input"],
Cell[24305, 754, 2249, 62, 180, "Input"],
Cell[26557, 818, 303, 9, 29, "Input"],
Cell[26863, 829, 669, 21, 63, "Input"],
Cell[27535, 852, 394, 11, 46, "Input"],
Cell[27932, 865, 305, 9, 46, "Input"],
Cell[28240, 876, 379, 10, 46, "Input"],
Cell[28622, 888, 288, 9, 29, "Input"],
Cell[28913, 899, 361, 10, 63, "Input"],
Cell[29277, 911, 185, 4, 29, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[29499, 920, 41, 0, 33, "Subsection"],
Cell[29543, 922, 69, 2, 121, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[29649, 929, 32, 0, 33, "Subsection"],
Cell[29684, 931, 58, 1, 121, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29791, 938, 27, 0, 60, "Section"],
Cell[CellGroupData[{
Cell[29843, 942, 34, 0, 41, "Subsection"],
Cell[29880, 944, 30, 0, 28, "Input"],
Cell[29913, 946, 183, 6, 29, "Text"],
Cell[30099, 954, 62, 1, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30198, 960, 41, 0, 41, "Subsection"],
Cell[CellGroupData[{
Cell[30264, 964, 56, 1, 28, "Input"],
Cell[30323, 967, 309, 5, 183, "Print",
 CellTags->"Info3563706972-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[30669, 977, 51, 1, 22, "Input"],
Cell[30723, 980, 269, 4, 183, "Print",
 CellTags->"Info3563706975-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[31029, 989, 53, 1, 22, "Input"],
Cell[31085, 992, 273, 4, 183, "Print",
 CellTags->"Info3563706978-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[31395, 1001, 52, 1, 21, "Input"],
Cell[31450, 1004, 199, 3, 183, "Print",
 CellTags->"Info3563707101-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[31686, 1012, 53, 1, 21, "Input"],
Cell[31742, 1015, 471, 7, 183, "Print",
 CellTags->"Info3563707107-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[32250, 1027, 58, 1, 22, "Input"],
Cell[32311, 1030, 596, 10, 183, "Print",
 CellTags->"Info3563707110-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[32944, 1045, 62, 1, 22, "Input"],
Cell[33009, 1048, 600, 9, 340, "Print",
 CellTags->"Info3563707113-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[33646, 1062, 50, 1, 21, "Input"],
Cell[33699, 1065, 481, 7, 183, "Print",
 CellTags->"Info3563707120-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[34217, 1077, 54, 1, 21, "Input"],
Cell[34274, 1080, 1090, 18, 272, "Print",
 CellTags->"Info3563707126-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[35401, 1103, 55, 1, 21, "Input"],
Cell[35459, 1106, 308, 5, 183, "Print",
 CellTags->"Info3563707129-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[35804, 1116, 54, 1, 21, "Input"],
Cell[35861, 1119, 354, 5, 183, "Print",
 CellTags->"Info3563707132-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[36252, 1129, 54, 1, 21, "Input"],
Cell[36309, 1132, 283, 5, 183, "Print",
 CellTags->"Info3563707136-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[36629, 1142, 55, 1, 22, "Input"],
Cell[36687, 1145, 1317, 20, 346, "Print",
 CellTags->"Info3563707139-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[38041, 1170, 56, 1, 22, "Input"],
Cell[38100, 1173, 281, 5, 262, "Print",
 CellTags->"Info3563707143-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[38418, 1183, 52, 1, 22, "Input"],
Cell[38473, 1186, 617, 10, 262, "Print",
 CellTags->"Info3563707145-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[39127, 1201, 58, 1, 22, "Input"],
Cell[39188, 1204, 435, 7, 58, "Print",
 CellTags->"Info3637581008-3104349"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39660, 1216, 59, 1, 29, "Input"],
Cell[39722, 1219, 484, 8, 262, "Print",
 CellTags->"Info3563708525-8207676"]
}, Closed]],
Cell[CellGroupData[{
Cell[40243, 1232, 47, 1, 21, "Input"],
Cell[40293, 1235, 268, 4, 183, "Print",
 CellTags->"Info3563707151-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[40598, 1244, 59, 1, 22, "Input"],
Cell[40660, 1247, 298, 5, 183, "Print",
 CellTags->"Info3563707154-2531470"]
}, Closed]],
Cell[CellGroupData[{
Cell[40995, 1257, 55, 1, 21, "Input"],
Cell[41053, 1260, 291, 5, 262, "Print",
 CellTags->"Info3563707264-2531470"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[41393, 1271, 56, 0, 33, "Subsection"],
Cell[CellGroupData[{
Cell[41474, 1275, 38, 0, 32, "Subsubsection"],
Cell[CellGroupData[{
Cell[41537, 1279, 84, 1, 121, "Input"],
Cell[41624, 1282, 36, 0, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[41697, 1287, 112, 2, 121, "Input"],
Cell[41812, 1291, 36, 0, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[41897, 1297, 33, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[41955, 1301, 75, 1, 121, "Input"],
Cell[42033, 1304, 177, 3, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[42259, 1313, 35, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[42319, 1317, 108, 3, 121, "Input"],
Cell[42430, 1322, 217, 5, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[42696, 1333, 34, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[42755, 1337, 231, 7, 121, "Input"],
Cell[42989, 1346, 219, 3, 272, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[43245, 1354, 314, 7, 197, "Input"],
Cell[43562, 1363, 885, 17, 245, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[44496, 1386, 35, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[44556, 1390, 254, 6, 121, "Input"],
Cell[44813, 1398, 93, 1, 121, "Output"]
}, Closed]],
Cell[44921, 1402, 184, 5, 121, "Input",
 CellTags->"9.4 Solutions"],
Cell[CellGroupData[{
Cell[45130, 1411, 160, 4, 121, "Input",
 CellTags->"9.4 Solutions"],
Cell[45293, 1417, 126, 3, 121, "Output",
 CellTags->"9.4 Solutions"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[45468, 1426, 40, 0, 25, "Subsubsection"],
Cell[45511, 1428, 158, 5, 151, "Input"],
Cell[CellGroupData[{
Cell[45694, 1437, 131, 3, 121, "Input"],
Cell[45828, 1442, 642, 18, 197, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[46519, 1466, 44, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[46588, 1470, 162, 3, 121, "Input"],
Cell[46753, 1475, 1007, 15, 415, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[47809, 1496, 32, 0, 25, "Subsubsection"],
Cell[47844, 1498, 147, 4, 121, "Input"],
Cell[CellGroupData[{
Cell[48016, 1506, 91, 2, 121, "Input"],
Cell[48110, 1510, 1208, 36, 343, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[49367, 1552, 36, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[49428, 1556, 89, 2, 121, "Input"],
Cell[49520, 1560, 137, 4, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[49694, 1569, 138, 4, 121, "Input"],
Cell[49835, 1575, 121, 3, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[50005, 1584, 37, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[50067, 1588, 76, 1, 121, "Input"],
Cell[50146, 1591, 31, 0, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[50226, 1597, 36, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[50287, 1601, 75, 1, 121, "Input"],
Cell[50365, 1604, 32, 0, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[50434, 1609, 76, 1, 121, "Input"],
Cell[50513, 1612, 31, 0, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[50581, 1617, 209, 5, 197, "Input"],
Cell[50793, 1624, 1598, 25, 415, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[52440, 1655, 36, 0, 25, "Subsubsection"],
Cell[52479, 1657, 64, 1, 121, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[52580, 1663, 37, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[52642, 1667, 149, 4, 121, "Input"],
Cell[52794, 1673, 36, 0, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[52867, 1678, 176, 5, 121, "Input"],
Cell[53046, 1685, 45, 0, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[53128, 1690, 221, 6, 121, "Input"],
Cell[53352, 1698, 165, 3, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[53554, 1706, 331, 9, 121, "Input"],
Cell[53888, 1717, 165, 3, 121, "Output"]
}, Closed]],
Cell[54068, 1723, 61, 0, 90, "Text"],
Cell[CellGroupData[{
Cell[54154, 1727, 320, 9, 121, "Input"],
Cell[54477, 1738, 234, 5, 96, "Message"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54760, 1749, 38, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[54823, 1753, 231, 7, 121, "Input"],
Cell[55057, 1762, 219, 3, 272, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[55313, 1770, 68, 1, 121, "Input"],
Cell[55384, 1773, 850, 16, 402, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[56271, 1794, 314, 7, 197, "Input"],
Cell[56588, 1803, 885, 17, 245, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[57522, 1826, 34, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[57581, 1830, 128, 3, 121, "Input"],
Cell[57712, 1835, 164, 6, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[57913, 1846, 141, 4, 121, "Input"],
Cell[58057, 1852, 170, 6, 121, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[58264, 1863, 128, 3, 121, "Input"],
Cell[58395, 1868, 269, 6, 96, "Message"],
Cell[58667, 1876, 152, 6, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[58868, 1888, 40, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[58933, 1892, 223, 6, 46, "Input"],
Cell[59159, 1900, 448, 8, 63, "Output"]
}, Open  ]],
Cell[59622, 1911, 282, 9, 34, "Input"],
Cell[CellGroupData[{
Cell[59929, 1924, 95, 2, 29, "Input"],
Cell[60027, 1928, 339, 6, 46, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[60415, 1940, 41, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[60481, 1944, 132, 3, 70, "Input"],
Cell[60616, 1949, 64, 0, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[60729, 1955, 29, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[60783, 1959, 68, 1, 121, "Input"],
Cell[60854, 1962, 39, 0, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[60942, 1968, 41, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[61008, 1972, 87, 1, 121, "Input"],
Cell[61098, 1975, 128, 3, 121, "Output"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61275, 1984, 37, 0, 25, "Subsubsection"],
Cell[CellGroupData[{
Cell[61337, 1988, 157, 3, 121, "Input"],
Cell[61497, 1993, 283, 5, 121, "Output"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

