(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14672,        560]
NotebookOptionsPosition[      9845,        421]
NotebookOutlinePosition[     12562,        506]
CellTagsIndexPosition[     12519,        503]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "Errata for ",
 StyleBox[ButtonBox["Programming with Mathematica: An Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.cambridge.org/wellin"], None},
  ButtonNote->"http://www.cambridge.org/wellin"],
  FontSlant->"Italic"]
}], "PrefaceSection"],

Cell[TextData[{
 StyleBox["Edition",
  FontWeight->"Bold"],
 ": First printing",
 StyleBox["\nAuthor",
  FontWeight->"Bold"],
 ": Paul R. Wellin\n",
 StyleBox["Copyright",
  FontWeight->"Bold"],
 ": ",
 StyleBox["\[Copyright]",
  FontSlant->"Plain"],
 " 2013 Cambridge University Press\n"
}], "AuthorInfo"],

Cell["Page 133, line 10", "Item"],

Cell[TextData[{
 "Replace ",
 StyleBox["{a_,b_}", "MR",
  FontSize->10],
 " with ",
 StyleBox["{a_,b__}", "MR",
  FontSize->10]
}], "TextFirst"],

Cell["Corrected in sources: Tue 29 Jan 2013 10:44:26", "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 152, lines ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "12"}], TraditionalForm]]],
 " through ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "15"}], TraditionalForm]]]
}], "Item"],

Cell["Wrong error message; should be:", "TextFirst"],

Cell[TextData[Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Part", "::", "partw"}], "MessageName"], ":", 
  " ", "\<\"Part \[NoBreak]\\!\\(6\\)\[NoBreak] of \[NoBreak]\\!\\({\\(\\({7, \
4, 0, 2, 6}\\)\\), \\(\\({7, 9, 8, 3, 9}\\)\\), \\(\\({8, 5, 2, 6, 2}\\)\\), \
\\(\\({6, 2, 0, 4, 1}\\)\\), \\(\\({7, 6, 8, 3, 6}\\)\\)}\\)\[NoBreak] does \
not exist. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\
\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/partw\\\", ButtonNote -> \
\\\"Part::partw\\\"]\\)\"\>"}]], "Message", "MSG",
 FontSize->9]], "TextFirst"],

Cell[TextData[{
 "Corrected in sources: ",
 StyleBox["Tue 15 Jan 2013 08:55:58",
  FontWeight->"Plain"]
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 159, lines ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "9"}], TraditionalForm]]],
 " through ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "11"}], TraditionalForm]]]
}], "Item"],

Cell[TextData[{
 StyleBox["Out[45]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 " does not match ",
 StyleBox["Out[44]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 ". ",
 StyleBox["Out[45]", "Menu",
  FontFamily->"Syntax LT Std",
  FontSize->9],
 " should be:"
}], "TextFirst"],

Cell[TextData[{
 "\t",
 Cell[BoxData[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{
    "\"\<ListCorrelate\>\"", ",", "\"\<DoubleLeftArrow\>\"", ",", 
     "\"\<NotebookClose\>\"", ",", "\"\<FileDate\>\"", ",", 
     "\"\<CylinderBox\>\"", ",", "\"\<SortBy\>\"", ",", 
     "\"\<PrecedesSlantEqual\>\"", ",", "\"\<Ordering\>\"", ",", 
     "\"\<Socket\>\"", ",", "\"\<PlotRangePadding\>\""}], "]"}],
   FontSize->10]]]
}], "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Tue 15 Jan 2013 08:42:07",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 314,  line ",
 Cell[BoxData[
  FormBox["9", TraditionalForm]]]
}], "Item"],

Cell[TextData[{
 "Change ",
 Cell[BoxData[
  FormBox[
   RowBox[{"a", "<", "b"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"b", "<", "a"}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Mon 15 Apr 2013 15:52:33"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 318,  line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "12"}], TraditionalForm]]]
}], "Item"],

Cell["\<\
Change second sentence to start: \[OpenCurlyDoubleQuote]For example, counting \
the occurrences of a word within a chunk\[Ellipsis]\[CloseCurlyDoubleQuote]\
\>", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Mon 15 Apr 2013 16:03:47"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 336,  line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "13"}], TraditionalForm]]]
}], "Item"],

Cell["\<\
\[OpenCurlyDoubleQuote]\[Ellipsis]an author a work.\" \[Rule] \"\[Ellipsis]an \
author of a work.\"\
\>", "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Sat 12 Jan 2013 11:16:32",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 338,  line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "12"}], TraditionalForm]]]
}], "Item"],

Cell["\<\
\[OpenCurlyDoubleQuote]Start be gathering\[Ellipsis]\" \[Rule] \"Start by \
gathering\[Ellipsis]\"\
\>", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Fri 12 Apr 2013 08:32:54"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell["Page 348,  line 7", "Item"],

Cell["\[OpenCurlyDoubleQuote]\[Ellipsis]tasks\[Ellipsis]\" \[Rule] \"\
\[Ellipsis]task\[Ellipsis]\"", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Fri 19 Apr 2013 15:49:30"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 357,  line ",
 Cell[BoxData[
  FormBox["7", TraditionalForm]]]
}], "Item"],

Cell["Remove closing parenthesis.", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Sat 6 Apr 2013 12:37:31"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 357,  line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "12"}], TraditionalForm]]]
}], "Item"],

Cell["Add period to end of paragraph.", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Tue 2 Apr 2013 08:19:00"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 380,  lines ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], " ", "and"}], " ", "-", "2"}], TraditionalForm]]]
}], "Item"],

Cell[TextData[{
 "Change ",
 Cell[BoxData["JoinedCuve"]],
 " to ",
 Cell[BoxData["JoinedCurve"]],
 ". Change ",
 Cell[BoxData["FilledCuve"]],
 " to ",
 Cell[BoxData["FilledCurve"]],
 "."
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Wed 12 Jun 2013 11:11:38"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell["Page 426,  lines 11 and 12", "Item"],

Cell[TextData[{
 "\[OpenCurlyDoubleQuote]\[Ellipsis]points inside the polygon black and those \
outside light gray.\[CloseCurlyDoubleQuote] Update ",
 StyleBox["Out[103]", "CellLabel",
  FontSize->8],
 " to reflect this."
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Wed 26 Jun 2013 22:06:15"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 513, line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "11"}], TraditionalForm]]]
}], "Item"],

Cell["Change \[OpenCurlyDoubleQuote]covert\[CloseCurlyDoubleQuote] to \
\[OpenCurlyDoubleQuote]convert\[CloseCurlyDoubleQuote]", "TextFirst"],

Cell[TextData[{
 "Corrected in sources: ",
 StyleBox["Tue 15 Jan 2013 13:51:43",
  FontWeight->"Plain"]
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 597, line ",
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "2"}], TraditionalForm]]]
}], "Item"],

Cell[TextData[{
 "Input cell containing the code for ",
 Cell[BoxData[
  StyleBox["PerfectSearchParallel",
   FontSize->10]]],
 ": change ",
 Cell[BoxData[
  StyleBox["Distribute",
   FontSize->10]]],
 " to ",
 Cell[BoxData[
  StyleBox["DistributeDefinitions",
   FontSize->10]]],
 "."
}], "TextFirst"],

Cell[TextData[StyleBox["Corrected in sources: Wed 5 Dec 2012 08:59:34",
 FontWeight->"Plain"]], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell[TextData[{
 "Page 600",
 StyleBox[", line ",
  FontWeight->"Plain"],
 Cell[BoxData[
  FormBox[
   RowBox[{"-", "5"}], TraditionalForm]],
  FontWeight->"Plain"]
}], "Item"],

Cell["\<\
Change \[OpenCurlyDoubleQuote]\[Ellipsis]not the need\[Ellipsis]\
\[CloseCurlyDoubleQuote] to \[OpenCurlyDoubleQuote]\[Ellipsis]note the need\
\[Ellipsis]\[CloseCurlyDoubleQuote]\
\>", "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Mon 1 Apr 2013 20:41:16"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell["Page 676\[Dash]677", "Item"],

Cell[TextData[{
 "Solutions to exercises ",
 StyleBox["2", "OsF"],
 " and ",
 StyleBox["3", "OsF"],
 " of Section ",
 StyleBox["12.2", "OsF"],
 " are out of order: exercise ",
 StyleBox["2", "OsF"],
 " should be numbered exercise 3 and vice versa."
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Mon 21 Jan 2013 14:43:30"
}], "TextFirst",
 FontColor->GrayLevel[0.5]],

Cell["Page 695", "Item"],

Cell[TextData[{
 "Add \[OpenCurlyDoubleQuote]",
 Cell[BoxData[
  FormBox["/.", TraditionalForm]]],
 ", ",
 Cell[BoxData["ReplaceAll"]],
 ", 102\[CloseCurlyDoubleQuote] to index; add ",
 Cell[BoxData[
  FormBox["//", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " (function application), 22 and ",
 Cell[BoxData[
  FormBox["@", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " (function application), 22 to index"
}], "TextFirst"],

Cell[TextData[{
 StyleBox["Corrected in sources: ",
  FontWeight->"Plain"],
 "Sat 4 May 2013 09:53:22"
}], "TextFirst",
 FontColor->GrayLevel[0.5]]
}, Open  ]]
},
ScreenStyleEnvironment->"Printout",
WindowSize->{930, 926},
WindowMargins->{{Automatic, 268}, {Automatic, 30}},
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, Automatic},
PageHeaders->{{
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
  None, None, 
   Cell[
    TextData[
     StyleBox[
      CounterBox["Page"], "PageNumber"]], "Header", 
    CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {None, None, None}},
PageHeaderLines->{False, False},
PageFooterLines->{False, False},
PrintingOptions->{"FacingPages"->True,
"FirstPageFace"->Right,
"FirstPageFooter"->True,
"FirstPageHeader"->False,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->54},
ShowSelection->True,
Magnification:>1.5 Inherited,
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"PWM"}, "PWM.nb", CharacterEncoding -> "UTF-8"]]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["TextFirst"]], 
      Cell[
       StyleData["TextFirst", "Printout"], CellMargins -> {{22, 0}, {2, 0}}, 
       PageBreakAbove -> False, FontFamily -> "DTL Albertina TOT", FontSize -> 
       10]}, Open]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["AuthorInfo"], MenuSortingValue -> 10000], 
      Cell[
       StyleData["AuthorInfo", "Printout"], 
       CellMargins -> {{12, Inherited}, {0, Inherited}}, MenuSortingValue -> 
       10000, FontFamily -> "DTL Albertina TOT", FontSize -> 10]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["PrefaceSection"]], 
      Cell[
       StyleData["PrefaceSection", "Printout"], 
       CellFrame -> {{0, 0}, {0, 0.5}}, CellMargins -> {{12, 0}, {2, 5}}, 
       CellFrameStyle -> Directive[
         GrayLevel[0.5]], FontFamily -> "DTL Albertina TOT", FontSize -> 14, 
       FontWeight -> "Plain"]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
       StyleData["Item"]], 
      Cell[
       StyleData["Item", "Printout"], CellMargins -> {{22, 4}, {4, 8}}, 
       FontFamily -> "DTL Albertina TOT Italic", FontSize -> 11]}, Closed]]}, 
  Visible -> False, FrontEndVersion -> 
  "9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, 2013)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 288, 8, 48, "PrefaceSection"],
Cell[870, 32, 306, 13, 83, "AuthorInfo"],
Cell[1179, 47, 33, 0, 38, "Item"],
Cell[1215, 49, 144, 7, 21, "TextFirst"],
Cell[1362, 58, 95, 1, 21, "TextFirst"],
Cell[1460, 61, 201, 9, 38, "Item"],
Cell[1664, 72, 52, 0, 21, "TextFirst"],
Cell[1719, 74, 600, 11, 37, "TextFirst"],
Cell[2322, 87, 148, 5, 21, "TextFirst"],
Cell[2473, 94, 200, 9, 38, "Item"],
Cell[2676, 105, 303, 13, 21, "TextFirst"],
Cell[2982, 120, 439, 12, 59, "TextFirst"],
Cell[3424, 134, 137, 2, 21, "TextFirst"],
Cell[3564, 138, 97, 4, 38, "Item"],
Cell[3664, 144, 266, 11, 21, "TextFirst"],
Cell[3933, 157, 148, 5, 21, "TextFirst"],
Cell[4084, 164, 117, 5, 38, "Item"],
Cell[4204, 171, 184, 3, 21, "TextFirst"],
Cell[4391, 176, 148, 5, 21, "TextFirst"],
Cell[4542, 183, 117, 5, 38, "Item"],
Cell[4662, 190, 128, 3, 21, "TextFirst"],
Cell[4793, 195, 137, 2, 21, "TextFirst"],
Cell[4933, 199, 117, 5, 38, "Item"],
Cell[5053, 206, 127, 3, 21, "TextFirst"],
Cell[5183, 211, 148, 5, 21, "TextFirst"],
Cell[5334, 218, 33, 0, 38, "Item"],
Cell[5370, 220, 114, 1, 21, "TextFirst"],
Cell[5487, 223, 148, 5, 21, "TextFirst"],
Cell[5638, 230, 97, 4, 38, "Item"],
Cell[5738, 236, 48, 0, 21, "TextFirst"],
Cell[5789, 238, 147, 5, 21, "TextFirst"],
Cell[5939, 245, 117, 5, 38, "Item"],
Cell[6059, 252, 52, 0, 21, "TextFirst"],
Cell[6114, 254, 147, 5, 21, "TextFirst"],
Cell[6264, 261, 175, 7, 38, "Item"],
Cell[6442, 270, 203, 10, 21, "TextFirst"],
Cell[6648, 282, 148, 5, 21, "TextFirst"],
Cell[6799, 289, 42, 0, 38, "Item"],
Cell[6844, 291, 238, 6, 21, "TextFirst"],
Cell[7085, 299, 148, 5, 21, "TextFirst"],
Cell[7236, 306, 116, 5, 38, "Item"],
Cell[7355, 313, 141, 1, 21, "TextFirst"],
Cell[7499, 316, 148, 5, 21, "TextFirst"],
Cell[7650, 323, 115, 5, 38, "Item"],
Cell[7768, 330, 302, 14, 42, "TextFirst"],
Cell[8073, 346, 136, 2, 21, "TextFirst"],
Cell[8212, 350, 176, 8, 38, "Item"],
Cell[8391, 360, 207, 4, 21, "TextFirst"],
Cell[8601, 366, 147, 5, 21, "TextFirst"],
Cell[8751, 373, 34, 0, 38, "Item"],
Cell[8788, 375, 265, 10, 42, "TextFirst"],
Cell[9056, 387, 148, 5, 21, "TextFirst"],
Cell[9207, 394, 24, 0, 38, "Item"],
Cell[9234, 396, 445, 15, 42, "TextFirst"],
Cell[9682, 413, 147, 5, 21, "TextFirst"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
